## ipmctl 02.00.00.3474+really01.00.00.3469

=== CMakeLists.txt ===
# Copyright (c) 2018, Intel Corporation.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 2.8.12)

project(ipmctl)

set(CMAKE_VERBOSE_MAKEFILE on)

get_filename_component(ROOT ./ ABSOLUTE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/CMake/Find")

set(LIBIPMCTL_VERSION_MAJOR 3)
set(LIBIPMCTL_VERSION_MINOR 1)
set(LIBIPMCTL_VERSION_PATCH 0)
set(LIBIPMCTL_VERSION_STRING ${LIBIPMCTL_VERSION_MAJOR}.${LIBIPMCTL_VERSION_MINOR}.${LIBIPMCTL_VERSION_PATCH})

set(IPMCTL_VERSION_MAJOR 01)
set(IPMCTL_VERSION_MINOR 00)
set(IPMCTL_VERSION_PATCH 00)

set(IPMCTL_SPEC_VERSION_MAJOR 1)
set(IPMCTL_SPEC_VERSION_MINOR 15)
set(IPMCTL_DRAFT "")
set(IPMCTL_SPEC_VERSION_STRING ${IPMCTL_SPEC_VERSION_MAJOR}.${IPMCTL_SPEC_VERSION_MINOR}${IPMCTL_DRAFT})

if(BUILDNUM)
	set(IPMCTL_VERSION_STRING ${BUILDNUM})
else()
	find_package(Git)
	if(GIT_FOUND)
		execute_process(COMMAND ${GIT_EXECUTABLE} describe --dirty
			OUTPUT_VARIABLE IPMCTL_VERSION_STRING
			RESULT_VARIABLE GIT_RETURN_CODE
			)
		# strip leading string in git tag
		string(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+)" IPMCTL_VERSION_STRING "${IPMCTL_VERSION_STRING}")
		# strip ending newline
		string(REGEX REPLACE "\n" "" IPMCTL_VERSION_STRING "${IPMCTL_VERSION_STRING}")
	endif()

	if(NOT GIT_FOUND OR ${GIT_RETURN_CODE})
		set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.9999)
	endif()
endif()

message(VERSION: ${IPMCTL_VERSION_STRING})

if(RELEASE)
	set(BUILD_TYPE release)
	set(CMAKE_BUILD_TYPE Release)
	SET(CMAKE_SKIP_BUILD_RPATH TRUE)
else()
	set(BUILD_TYPE debug)
	set(CMAKE_BUILD_TYPE Debug)
	add_definitions(
		-DDEBUG_BUILD
		)
endif()

message(BUILD_TYPE: ${CMAKE_BUILD_TYPE})

if(BUILD_STATIC)
	set(LIB_TYPE STATIC)
else()
	set(LIB_TYPE SHARED)
endif()

if(ESX_BUILD)
	set(OS_TYPE esx)
	set(FILE_PREFIX esx)
	find_package(PythonInterp REQUIRED)
elseif(UNIX)
	set(LNX_BUILD 1)
	set(OS_TYPE linux)
	set(FILE_PREFIX lnx)

	find_package(Threads REQUIRED)
	find_package(PkgConfig REQUIRED)
	find_package(PythonInterp REQUIRED)
	find_package(asciidoctor)
	find_package(asciidoc)
	pkg_check_modules(NDCTL REQUIRED libndctl>=58.2)
	pkg_check_modules(SYSTEMD systemd)
if(NOT SAFECLIB_SRC_DOWNLOAD_AND_STATIC_LINK)
	pkg_check_modules(LIBSAFEC REQUIRED safec-3.3>=03032018.0-g570fa5)
endif()
elseif(MSVC)
	set(WIN_BUILD 1)
	set(OS_TYPE win)
	set(FILE_PREFIX win)
	find_package(PythonInterp REQUIRED)
endif()

message(BUILD_TYPE: ${CMAKE_BUILD_TYPE})
message(OS_TYPE: ${OS_TYPE})
message(LIB_TYPE: ${LIB_TYPE})
message(COMPILER: ${CMAKE_C_COMPILER})
message(SYSROOT: ${MY_CMAKE_SYSROOT})
message(TOOLCHAIN: ${CMAKE_TOOLCHAIN_FILE})

set(OUTPUT_DIR ${ROOT}/output/${BUILD_TYPE})
file(MAKE_DIRECTORY ${OUTPUT_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${ROOT}/output/${BUILD_TYPE})
set(CMAKE_BINARY_DIR ${OUTPUT_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

if(INTERNAL_MFG)
        include(CMake/mfg.cmake)
endif()

#----------------------------------------------------------------------------------------------------
# Project wide defines and flags
#----------------------------------------------------------------------------------------------------
add_definitions(
	-DOS_BUILD
	-DPCD_CACHE_ENABLED
	-D__VERSION_NUMBER__=${IPMCTL_VERSION_STRING}
	-DPLAYBACK_RECORD_SUPPORTED
	)

# Promote warnings to errors only for release builds
if(MSVC)
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /O2 /WX")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /O2 /WX")
	set(CMAKE_C_FLAGS_DEBUG_ "${CMAKE_C_FLAGS_DEBUG} /Od")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /Od")
else()
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O2 -fno-strict-aliasing -D_FORTIFY_SOURCE=2")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O2 -fno-strict-aliasing -D_FORTIFY_SOURCE=2")
	if(LNX_BUILD)
		#A few warnings yet to resolve under esx
		set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -Werror")
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -Werror")
	endif()
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -ggdb")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -ggdb")
endif()

if(UNIX)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DNO_MSABI_VA_FUNCS -std=c99 -Wformat -Wformat-security -D_XOPEN_SOURCE=500 -Wall -Wfatal-errors -MMD -fPIC -fno-strict-aliasing")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wformat -Wformat-security -D_XOPEN_SOURCE=500 -Drestrict=__restrict__ -Wall -Wfatal-errors -MMD -fPIC -fno-strict-aliasing")
	set(CMAKE_SHARED_LINKER_FLAGS "-z noexecstack -z relro -z now -pie")
elseif(MSVC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /GS /DynamicBase /sdl")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GS /DynamicBase /sdl")
	set(CMAKE_SHARED_LINKER_FLAGS "/NXCompat")
endif()

if(LNX_BUILD)
	add_definitions(
		-D_GNU_SOURCE
		-D__LINUX__
		-DHAVE_C99
		)
	if(CMAKE_C_COMPILER_ID STREQUAL "GNU" AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.9)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong")
	endif()
	if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.9)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong")
	endif()
endif()

if(MSVC)
	if(VCREDIST_STATIC)
		# Force vcredist to be linked static
		# Keep this after all other compiler flag setup
		set(CompilerFlags
				CMAKE_CXX_FLAGS
				CMAKE_CXX_FLAGS_DEBUG
				CMAKE_CXX_FLAGS_RELEASE
				CMAKE_CXX_FLAGS_RELWITHDEBINFO
				CMAKE_C_FLAGS
				CMAKE_C_FLAGS_DEBUG
				CMAKE_C_FLAGS_RELEASE
				CMAKE_C_FLAGS_RELWITHDEBINFO
				)
		foreach(CompilerFlag ${CompilerFlags})
		  string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
		endforeach()
		message("VCREDIST: STATIC")
	else()
		message("VCREDIST: SHARED")
	endif()
endif()
#----------------------------------------------------------------------------------------------------
# OS driver interface library
#----------------------------------------------------------------------------------------------------

if(MSVC)
	FILE(GLOB OS_INTERFACE_SOURCE_FILES
		src/os/os_common.c
		src/os/win/win_scm2_ioctl.c
		src/os/win/win_scm2_passthrough.c
		src/os/win/win_scm2_ioctl_passthrough.c
		src/os/win/win_common.c
		src/os/win/win_api.c
		src/os/win/win_adapter_acpi_events.c
		src/os/win/win_scm2_adapter.c
		src/os/win/win_system.c
		)
elseif(UNIX)
	FILE(GLOB OS_INTERFACE_SOURCE_FILES
		src/os/os_common.c
		src/os/${OS_TYPE}/${FILE_PREFIX}_adapter_passthrough.c
		src/os/${OS_TYPE}/${FILE_PREFIX}_acpi.c
		src/os/${OS_TYPE}/${FILE_PREFIX}_common.c
		src/os/${OS_TYPE}/${FILE_PREFIX}_api.c
		src/os/${OS_TYPE}/${FILE_PREFIX}_adapter.c
		src/os/${OS_TYPE}/${FILE_PREFIX}_adapter_acpi_events.c
		src/os/${OS_TYPE}/${FILE_PREFIX}_system.c
		)
endif()

add_library(ipmctl_os_interface STATIC ${OS_INTERFACE_SOURCE_FILES})

target_link_libraries(ipmctl_os_interface
	${CMAKE_THREAD_LIBS_INIT}
	)

if(LNX_BUILD AND (NOT SAFECLIB_SRC_DOWNLOAD_AND_STATIC_LINK))
	target_link_libraries(ipmctl_os_interface
		${LIBSAFEC_LIBRARIES}
		)
endif()

target_include_directories(ipmctl_os_interface PUBLIC
	src/os
	src/os/${OS_TYPE}
	DcpmPkg/common
	src/os/nvm_api
	src/os/s_string
	${LIBSAFEC_INCLUDE_DIRS}
	)
# TODO: Remove the backup winioctl.h file when the 17650+ Windows SDK is publicly released
if (MSVC)
	string(REGEX REPLACE "([0-9]+)\\.[0-9]+\\.[0-9]+\\.[0-9]+" "\\1" sdk_version_major $ENV{WindowsSDKVersion})
	string(REGEX REPLACE "[0-9]+\\.([0-9]+)\\.[0-9]+\\.[0-9]+" "\\1" sdk_version_major2 $ENV{WindowsSDKVersion})
	string(REGEX REPLACE "[0-9]+\\.[0-9]+\\.([0-9]+)\\.[0-9]+" "\\1" sdk_version_minor $ENV{WindowsSDKVersion})
	if (${sdk_version_major} GREATER 9 AND ${sdk_version_minor} GREATER 17650)
		MESSAGE("Using Windows SDK 17650+")
	else()
		MESSAGE("Using internal winioctl.h")
		target_include_directories(ipmctl_os_interface PUBLIC
			src/os/win/sdk
		)
	endif()
endif()

#----------------------------------------------------------------------------------------------------
# libipmctl
#----------------------------------------------------------------------------------------------------
file(GLOB LIBIPMCTL_SOURCE_FILES
	src/os/efi_shim/AutoGen.c
	src/os/efi_shim/os_efi_api.c
	src/os/efi_shim/os_efi_preferences.c
	src/os/efi_shim/os_efi_shell_parameters_protocol.c
	src/os/efi_shim/os_efi_simple_file_protocol.c
	src/os/efi_shim/os_efi_bs_protocol.c
	src/os/ini/ini.c
	src/os/eventlog/event.c
	src/os/nvm_api/nvm_management.c
	src/os/nvm_api/nvm_output_parsing.c
	src/os/s_string/s_str.c
	DcpmPkg/cli/NvmDimmCli.c
	DcpmPkg/cli/CommandParser.c
	DcpmPkg/cli/Common.c
	DcpmPkg/cli/ShowAcpiCommand.c
	DcpmPkg/cli/ShowSensorCommand.c
	DcpmPkg/cli/ShowDimmsCommand.c
	DcpmPkg/cli/ShowSocketsCommand.c
	DcpmPkg/cli/ShowMemoryResourcesCommand.c
	DcpmPkg/cli/ShowSystemCapabilitiesCommand.c
	DcpmPkg/cli/ShowFirmwareCommand.c
	DcpmPkg/cli/ShowPcdCommand.c
	DcpmPkg/cli/DeletePcdCommand.c
	DcpmPkg/cli/ShowRegionsCommand.c
	DcpmPkg/cli/CreateGoalCommand.c
	DcpmPkg/cli/ShowGoalCommand.c
	DcpmPkg/cli/DeleteGoalCommand.c
	DcpmPkg/cli/ShowErrorCommand.c
	DcpmPkg/cli/DumpDebugCommand.c
	DcpmPkg/cli/StartDiagnosticCommand.c
	DcpmPkg/cli/ShowPreferencesCommand.c
	DcpmPkg/cli/ShowTopologyCommand.c
	DcpmPkg/cli/SetPreferencesCommand.c
	DcpmPkg/cli/SetSensorCommand.c
	DcpmPkg/cli/LoadGoalCommand.c
	DcpmPkg/cli/DumpGoalCommand.c
	DcpmPkg/cli/SetDimmCommand.c
	DcpmPkg/cli/LoadCommand.c
	DcpmPkg/cli/DeleteDimmCommand.c
	src/os/cli_cmds/DumpSupportCommand.c
	DcpmPkg/cli/ShowRegisterCommand.c
	DcpmPkg/cli/StartFormatCommand.c
	DcpmPkg/cli/ShowEventCommand.c
	DcpmPkg/cli/SetEventCommand.c
	DcpmPkg/cli/ShowPerformanceCommand.c
	DcpmPkg/cli/ShowHostServerCommand.c
	DcpmPkg/cli/ShowCmdAccessPolicyCommand.c
	DcpmPkg/common/FwUtility.c
	DcpmPkg/common/Utility.c
	DcpmPkg/common/NvmTables.c
	DcpmPkg/common/ShowAcpi.c
	DcpmPkg/common/NvmStatus.c
	DcpmPkg/common/NvmHealth.c
	DcpmPkg/common/LbaCommon.c
	DcpmPkg/common/Convert.c
	DcpmPkg/common/PcdCommon.c
	DcpmPkg/common/OsCommon.c
	DcpmPkg/common/DataSet.c
	DcpmPkg/common/Printer.c
	DcpmPkg/common/Strings.c
	DcpmPkg/common/Nlog.c
	DcpmPkg/driver/Protocol/Driver/NvmDimmConfig.c
	DcpmPkg/driver/NvmDimmDriver.c
	DcpmPkg/driver/Core/Dimm.c
	DcpmPkg/driver/Core/Namespace.c
	DcpmPkg/driver/Core/NvmSecurity.c
	DcpmPkg/driver/Core/Region.c
	DcpmPkg/driver/Core/Btt.c
	DcpmPkg/driver/Core/Pfn.c
	DcpmPkg/driver/Core/Diagnostics/ConfigDiagnostic.c
	DcpmPkg/driver/Core/Diagnostics/CoreDiagnostics.c
	DcpmPkg/driver/Core/Diagnostics/FwDiagnostic.c
	DcpmPkg/driver/Core/Diagnostics/QuickDiagnostic.c
	DcpmPkg/driver/Core/Diagnostics/SecurityDiagnostic.c
	DcpmPkg/driver/Protocol/Device/NvmFirmwareManagement.c
	DcpmPkg/driver/Protocol/Namespace/NvmDimmBlockIo.c
	DcpmPkg/driver/Utils/PlatformConfigData.c
	DcpmPkg/driver/Utils/AcpiParsing.c
	DcpmPkg/driver/Utils/ProcessorAndTopologyInfo.c
	DcpmPkg/driver/Utils/Interleave.c
	DcpmPkg/driver/Utils/SmbiosUtility.c
	DcpmPkg/driver/Utils/DumpLoadRegions.c
	MdePkg/Library/UefiDevicePathLib/UefiDevicePathLib.c
	MdePkg/Library/UefiDevicePathLib/DevicePathUtilities.c
	MdePkg/Library/UefiDevicePathLib/DevicePathToText.c
	MdePkg/Library/UefiDevicePathLib/DevicePathFromText.c
	MdePkg/Library/BaseLib/Math64.c
	MdePkg/Library/BaseLib/MultU64x32.c
	MdePkg/Library/BaseLib/DivU64x32Remainder.c
	MdePkg/Library/BaseLib/Unaligned.c
	MdePkg/Library/BaseLib/BitField.c
	MdePkg/Library/BaseLib/LinkedList.c
	MdePkg/Library/BaseLib/LShiftU64.c
	MdePkg/Library/BaseLib/Math64.c
	MdePkg/Library/BaseLib/SwapBytes64.c
	MdePkg/Library/BaseLib/SwapBytes32.c
	MdePkg/Library/BaseLib/SwapBytes16.c
	MdePkg/Library/BaseLib/String.c
	MdePkg/Library/BaseLib/SafeString.c
	MdePkg/Library/BaseLib/RShiftU64.c
	MdePkg/Library/BaseLib/Math64.c
	MdePkg/Library/BaseLib/DivU64x32.c
	${LIBIPMCTL_MFG_FILES}
	)
if(EXISTS "${ROOT}/CMake/internal.cmake")
        include("${ROOT}/CMake/internal.cmake")
endif()

=== debian/changelog ===
ipmctl (02.00.00.3474+really01.00.00.3469-1) unstable; urgency=medium

  * Downgrade to the stable branch (v2 releases are still alpha).

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 18 Aug 2019 15:59:18 +0200

ipmctl (02.00.00.3474+ds-2) unstable; urgency=medium

  * Rebuild on buildds.
  * Minor copyright improvements.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 13 Aug 2019 12:14:30 +0200

ipmctl (02.00.00.3474+ds-1) unstable; urgency=low

  * Initial release (closes: #931643)

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 08 Jul 2019 19:52:35 +0200

=== debian/control ===
Source: ipmctl
Section: admin
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libndctl-dev,
               pkg-config,
               python3,
               libsafec-dev,
               asciidoctor
Standards-Version: 4.4.0
Homepage: https://github.com/intel/ipmctl
Vcs-Browser: https://github.com/kilobyte/ipmctl/tree/debian
Vcs-Git: https://github.com/kilobyte/ipmctl -b debian

Package: ipmctl
Architecture: amd64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: utility for configuring and managing Intel Optane DC persistent memory modules
 This package provides a CLI with the following functionality:
  * Discover PMMs on the platform.
  * Provision the platform memory configuration.
  * View and update the firmware on PMMs.
  * Configure data-at-rest security on PMMs.
  * Monitor PMM health.
  * Track performance of PMMs.
  * Debug and troubleshoot PMMs.

Package: libipmctl3
Section: libs
Architecture: amd64
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: library for managing Intel Optane DC persistent memory modules
 This package provides an API for the following functionality:
  * Discover PMMs on the platform.
  * Provision the platform memory configuration.
  * View and update the firmware on PMMs.
  * Configure data-at-rest security on PMMs.
  * Monitor PMM health.
  * Track performance of PMMs.
  * Debug and troubleshoot PMMs
 .
 This package contains runtime library and common conf files.

Package: libipmctl-dev
Section: libdevel
Architecture: amd64
Multi-Arch: same
Depends: libipmctl3 (=${binary:Version}),
         ${misc:Depends}
Description: library for managing Intel Optane DC persistent memory modules - devel
 This package provides an API for the following functionality:
  * Discover PMMs on the platform.
  * Provision the platform memory configuration.
  * View and update the firmware on PMMs.
  * Configure data-at-rest security on PMMs.
  * Monitor PMM health.
  * Track performance of PMMs.
  * Debug and troubleshoot PMMs.
 .
 This package contains C development headers.

Package: ipmctl-monitor
Architecture: amd64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: daemon for monitoring health and status of Intel Optane DC modules
 This is a daemon which watches and logs events related to Optane DC
 NVDIMMs, such as media errors, thermal issues, losing or regaining contact
 with the memory controller, etc.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@  

override_dh_auto_configure:
	dh_auto_configure -- \
	      -DBUILDNUM=`dpkg-parsechangelog -SVersion|cut -d+ -f1`

override_dh_install:
	mkdir -p debian/tmp/usr/sbin
	mv debian/tmp/usr/bin/ipmctl-monitor debian/tmp/usr/sbin/ipmctl-monitor
	dh_install

overide_dh_clean:
	dh_clean
	rm -rf output

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ipmctl-$1.tar.gz%, repack, repacksuffix=+ds, dversionmangle=s/\+ds//" \
   https://github.com/intel/ipmctl/tags \
   (?:.*?/)?v?(01\.\d[\d.]*)\.tar\.gz debian uupdate

## ipmctl 02.00.00.3709%2Bds

=== debian/changelog ===
ipmctl (02.00.00.3709+ds-1) unstable; urgency=medium

  * A new upstream snapshot.
    + Fixes bad parsing of v0.1 PMTT data.  Closes: #951075.
  * Update symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 10 Feb 2020 23:44:47 +0100

ipmctl (02.00.00.3673+ds-3) unstable; urgency=medium

  * Purge libipmctl3's conffile, unbreaking logrotate.  Closes: #949850.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 26 Jan 2020 19:39:29 +0100

ipmctl (02.00.00.3673+ds-2) unstable; urgency=medium

  * Upload the beta to unstable.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 21 Jan 2020 15:18:53 +0100

ipmctl (02.00.00.3673+ds-1) experimental; urgency=medium

  * New upstream alpha release.
  * Include library symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 15 Dec 2019 03:48:05 +0100

ipmctl (02.00.00.3658+ds-1) experimental; urgency=medium

  * New upstream alpha release.
  * Drop safeclib from B-Deps.
  * The ipmctl-monitor daemon package is no more.
  * Bump lib package version for soname to libipmctl4.
  * Follow upstream renaming of the lib's logfile logrotate config.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 05 Dec 2019 19:17:03 +0100

## ipmctl 02.00.00.3709+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,8 @@
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/CMake/Find")
 
-set(LIBIPMCTL_VERSION_MAJOR 3)
-set(LIBIPMCTL_VERSION_MINOR 1)
+set(LIBIPMCTL_VERSION_MAJOR 4)
+set(LIBIPMCTL_VERSION_MINOR 0)
 set(LIBIPMCTL_VERSION_PATCH 0)
 set(LIBIPMCTL_VERSION_STRING ${LIBIPMCTL_VERSION_MAJOR}.${LIBIPMCTL_VERSION_MINOR}.${LIBIPMCTL_VERSION_PATCH})
 
@@ -20,9 +20,9 @@
 set(IPMCTL_VERSION_MINOR 00)
 set(IPMCTL_VERSION_PATCH 00)
 
-set(IPMCTL_SPEC_VERSION_MAJOR 1)
-set(IPMCTL_SPEC_VERSION_MINOR 15)
-set(IPMCTL_DRAFT "")
+set(IPMCTL_SPEC_VERSION_MAJOR 2)
+set(IPMCTL_SPEC_VERSION_MINOR 03)
+set(IPMCTL_DRAFT "-draft")
 set(IPMCTL_SPEC_VERSION_STRING ${IPMCTL_SPEC_VERSION_MAJOR}.${IPMCTL_SPEC_VERSION_MINOR}${IPMCTL_DRAFT})
 
 if(BUILDNUM)
@@ -30,7 +30,7 @@
 else()
 	find_package(Git)
 	if(GIT_FOUND)
-		execute_process(COMMAND ${GIT_EXECUTABLE} describe --dirty
+		execute_process(COMMAND ${GIT_EXECUTABLE} describe --tag --dirty
 			OUTPUT_VARIABLE IPMCTL_VERSION_STRING
 			RESULT_VARIABLE GIT_RETURN_CODE
 			)
@@ -83,14 +83,13 @@
 	find_package(asciidoc)
 	pkg_check_modules(NDCTL REQUIRED libndctl>=58.2)
 	pkg_check_modules(SYSTEMD systemd)
-if(NOT SAFECLIB_SRC_DOWNLOAD_AND_STATIC_LINK)
-	pkg_check_modules(LIBSAFEC REQUIRED safec-3.3>=03032018.0-g570fa5)
-endif()
 elseif(MSVC)
 	set(WIN_BUILD 1)
 	set(OS_TYPE win)
 	set(FILE_PREFIX win)
 	find_package(PythonInterp REQUIRED)
+	find_package(asciidoctor)
+	find_package(asciidoc)
 endif()
 
 message(BUILD_TYPE: ${CMAKE_BUILD_TYPE})
@@ -151,10 +150,28 @@
 endif()
 
 if(LNX_BUILD)
+	if("${CMAKE_INSTALL_DATAROOTDIR}" STREQUAL "/usr/share")
+		# Workaround for the RPM build cause the %{_datarootdir} is already prefixed
+		set(INI_INSTALL_FILEPATH "${CMAKE_INSTALL_DATAROOTDIR}")
+	else()
+		if("${CMAKE_INSTALL_PREFIX}" STREQUAL "/")
+			# In case the CMAKE_INSTALL_PREFIX equals "/" for <dir> other than the SYSCONFDIR and LOCALSTATEDIR,
+			# the value of CMAKE_INSTALL_<dir> is prefixed with usr/ if it is not user-specified as an absolute path.
+			set(CMAKE_INSTALL_PREFIX "/usr")
+			message("CMAKE_INSTALL_PREFIX value changed to: ${CMAKE_INSTALL_PREFIX}")
+		endif()
+		if(NOT DEFINED CMAKE_INSTALL_DATAROOTDIR)
+			set(CMAKE_INSTALL_DATAROOTDIR "share")
+			message("CMAKE_INSTALL_DATAROOTDIR not defined. Creating a new definition with value: ${CMAKE_INSTALL_DATAROOTDIR}")
+		endif()
+		set(INI_INSTALL_FILEPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}")
+	endif()
+	message("INI_INSTALL_FILEPATH definition create with value: ${INI_INSTALL_FILEPATH}")
 	add_definitions(
 		-D_GNU_SOURCE
 		-D__LINUX__
 		-DHAVE_C99
+		-DINI_INSTALL_FILEPATH="${INI_INSTALL_FILEPATH}/ipmctl/"
 		)
 	if(CMAKE_C_COMPILER_ID STREQUAL "GNU" AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.9)
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong")
@@ -192,25 +209,25 @@
 
 if(MSVC)
 	FILE(GLOB OS_INTERFACE_SOURCE_FILES
+		src/os/os_str.c
 		src/os/os_common.c
 		src/os/win/win_scm2_ioctl.c
 		src/os/win/win_scm2_passthrough.c
 		src/os/win/win_scm2_ioctl_passthrough.c
 		src/os/win/win_common.c
 		src/os/win/win_api.c
-		src/os/win/win_adapter_acpi_events.c
 		src/os/win/win_scm2_adapter.c
 		src/os/win/win_system.c
 		)
 elseif(UNIX)
 	FILE(GLOB OS_INTERFACE_SOURCE_FILES
+		src/os/os_str.c
 		src/os/os_common.c
 		src/os/${OS_TYPE}/${FILE_PREFIX}_adapter_passthrough.c
 		src/os/${OS_TYPE}/${FILE_PREFIX}_acpi.c
 		src/os/${OS_TYPE}/${FILE_PREFIX}_common.c
 		src/os/${OS_TYPE}/${FILE_PREFIX}_api.c
 		src/os/${OS_TYPE}/${FILE_PREFIX}_adapter.c
-		src/os/${OS_TYPE}/${FILE_PREFIX}_adapter_acpi_events.c
 		src/os/${OS_TYPE}/${FILE_PREFIX}_system.c
 		)
 endif()
@@ -220,12 +237,6 @@
 target_link_libraries(ipmctl_os_interface
 	${CMAKE_THREAD_LIBS_INIT}
 	)
-
-if(LNX_BUILD AND (NOT SAFECLIB_SRC_DOWNLOAD_AND_STATIC_LINK))
-	target_link_libraries(ipmctl_os_interface
-		${LIBSAFEC_LIBRARIES}
-		)
-endif()
 
 target_include_directories(ipmctl_os_interface PUBLIC
 	src/os
@@ -233,7 +244,6 @@
 	DcpmPkg/common
 	src/os/nvm_api
 	src/os/s_string
-	${LIBSAFEC_INCLUDE_DIRS}
 	)
 # TODO: Remove the backup winioctl.h file when the 17650+ Windows SDK is publicly released
 if (MSVC)
@@ -282,6 +292,7 @@
 	DcpmPkg/cli/ShowGoalCommand.c
 	DcpmPkg/cli/DeleteGoalCommand.c
 	DcpmPkg/cli/ShowErrorCommand.c
+	DcpmPkg/cli/ShowCelCommand.c
 	DcpmPkg/cli/DumpDebugCommand.c
 	DcpmPkg/cli/StartDiagnosticCommand.c
 	DcpmPkg/cli/ShowPreferencesCommand.c
@@ -296,11 +307,14 @@
 	src/os/cli_cmds/DumpSupportCommand.c
 	DcpmPkg/cli/ShowRegisterCommand.c
 	DcpmPkg/cli/StartFormatCommand.c
-	DcpmPkg/cli/ShowEventCommand.c
-	DcpmPkg/cli/SetEventCommand.c
 	DcpmPkg/cli/ShowPerformanceCommand.c
 	DcpmPkg/cli/ShowHostServerCommand.c
 	DcpmPkg/cli/ShowCmdAccessPolicyCommand.c
+	DcpmPkg/cli/StartSessionCommand.c
+	DcpmPkg/cli/StopSessionCommand.c
+	DcpmPkg/cli/LoadSessionCommand.c
+	DcpmPkg/cli/ShowSessionCommand.c
+	DcpmPkg/cli/DumpSessionCommand.c
 	DcpmPkg/common/FwUtility.c
 	DcpmPkg/common/Utility.c
 	DcpmPkg/common/NvmTables.c
@@ -315,6 +329,7 @@
 	DcpmPkg/common/Printer.c
 	DcpmPkg/common/Strings.c
 	DcpmPkg/common/Nlog.c
+	DcpmPkg/common/ReadRunTimePreferences.c
 	DcpmPkg/driver/Protocol/Driver/NvmDimmConfig.c
 	DcpmPkg/driver/NvmDimmDriver.c
 	DcpmPkg/driver/Core/Dimm.c
@@ -335,29 +350,3 @@
 	DcpmPkg/driver/Utils/ProcessorAndTopologyInfo.c
 	DcpmPkg/driver/Utils/Interleave.c
 	DcpmPkg/driver/Utils/SmbiosUtility.c
-	DcpmPkg/driver/Utils/DumpLoadRegions.c
-	MdePkg/Library/UefiDevicePathLib/UefiDevicePathLib.c
-	MdePkg/Library/UefiDevicePathLib/DevicePathUtilities.c
-	MdePkg/Library/UefiDevicePathLib/DevicePathToText.c
-	MdePkg/Library/UefiDevicePathLib/DevicePathFromText.c
-	MdePkg/Library/BaseLib/Math64.c
-	MdePkg/Library/BaseLib/MultU64x32.c
-	MdePkg/Library/BaseLib/DivU64x32Remainder.c
-	MdePkg/Library/BaseLib/Unaligned.c
-	MdePkg/Library/BaseLib/BitField.c
-	MdePkg/Library/BaseLib/LinkedList.c
-	MdePkg/Library/BaseLib/LShiftU64.c
-	MdePkg/Library/BaseLib/Math64.c
-	MdePkg/Library/BaseLib/SwapBytes64.c
-	MdePkg/Library/BaseLib/SwapBytes32.c
-	MdePkg/Library/BaseLib/SwapBytes16.c
-	MdePkg/Library/BaseLib/String.c
-	MdePkg/Library/BaseLib/SafeString.c
-	MdePkg/Library/BaseLib/RShiftU64.c
-	MdePkg/Library/BaseLib/Math64.c
-	MdePkg/Library/BaseLib/DivU64x32.c
-	${LIBIPMCTL_MFG_FILES}
-	)
-if(EXISTS "${ROOT}/CMake/internal.cmake")
-        include("${ROOT}/CMake/internal.cmake")
-endif()

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,9 @@
                libndctl-dev,
                pkg-config,
                python3,
-               libsafec-dev,
                asciidoctor
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://github.com/intel/ipmctl
 Vcs-Browser: https://github.com/kilobyte/ipmctl/tree/debian
 Vcs-Git: https://github.com/kilobyte/ipmctl -b debian
@@ -28,12 +28,14 @@
   * Track performance of PMMs.
   * Debug and troubleshoot PMMs.
 
-Package: libipmctl3
+Package: libipmctl4
 Section: libs
 Architecture: amd64
 Multi-Arch: same
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Breaks: libipmctl3
+Replaces: libipmctl3
 Description: library for managing Intel Optane DC persistent memory modules
  This package provides an API for the following functionality:
   * Discover PMMs on the platform.
@@ -50,7 +52,7 @@
 Section: libdevel
 Architecture: amd64
 Multi-Arch: same
-Depends: libipmctl3 (=${binary:Version}),
+Depends: libipmctl4 (=${binary:Version}),
          ${misc:Depends}
 Description: library for managing Intel Optane DC persistent memory modules - devel
  This package provides an API for the following functionality:
@@ -63,13 +65,3 @@
   * Debug and troubleshoot PMMs.
  .
  This package contains C development headers.
-
-Package: ipmctl-monitor
-Architecture: amd64
-Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends},
-         ${misc:Depends}
-Description: daemon for monitoring health and status of Intel Optane DC modules
- This is a daemon which watches and logs events related to Optane DC
- NVDIMMs, such as media errors, thermal issues, losing or regaining contact
- with the memory controller, etc.

=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,6 @@
 	dh_auto_configure -- \
 	      -DBUILDNUM=`dpkg-parsechangelog -SVersion|cut -d+ -f1`
 
-override_dh_install:
-	mkdir -p debian/tmp/usr/sbin
-	mv debian/tmp/usr/bin/ipmctl-monitor debian/tmp/usr/sbin/ipmctl-monitor
-	dh_install
-
 overide_dh_clean:
 	dh_clean
 	rm -rf output

## ipmctl 02.00.00.3774+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,8 @@
 # SPDX-License-Identifier: BSD-3-Clause
 
 cmake_minimum_required(VERSION 2.8.12)
+
+message("cmake version: " ${CMAKE_VERSION})
 
 project(ipmctl)
 
@@ -16,12 +18,12 @@
 set(LIBIPMCTL_VERSION_PATCH 0)
 set(LIBIPMCTL_VERSION_STRING ${LIBIPMCTL_VERSION_MAJOR}.${LIBIPMCTL_VERSION_MINOR}.${LIBIPMCTL_VERSION_PATCH})
 
-set(IPMCTL_VERSION_MAJOR 01)
+set(IPMCTL_VERSION_MAJOR 02)
 set(IPMCTL_VERSION_MINOR 00)
 set(IPMCTL_VERSION_PATCH 00)
 
 set(IPMCTL_SPEC_VERSION_MAJOR 2)
-set(IPMCTL_SPEC_VERSION_MINOR 03)
+set(IPMCTL_SPEC_VERSION_MINOR 05)
 set(IPMCTL_DRAFT "-draft")
 set(IPMCTL_SPEC_VERSION_STRING ${IPMCTL_SPEC_VERSION_MAJOR}.${IPMCTL_SPEC_VERSION_MINOR}${IPMCTL_DRAFT})
 
@@ -41,7 +43,7 @@
 	endif()
 
 	if(NOT GIT_FOUND OR ${GIT_RETURN_CODE})
-		set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.9999)
+		set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.3774)
 	endif()
 endif()
 
@@ -70,6 +72,9 @@
 if(ESX_BUILD)
 	set(OS_TYPE esx)
 	set(FILE_PREFIX esx)
+	set(CMAKE_SKIP_BUILD_RPATH FALSE)
+	set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
+	set(CMAKE_INSTALL_RPATH "/opt/intel/bin")
 	find_package(PythonInterp REQUIRED)
 elseif(UNIX)
 	set(LNX_BUILD 1)
@@ -245,7 +250,7 @@
 	src/os/nvm_api
 	src/os/s_string
 	)
-# TODO: Remove the backup winioctl.h file when the 17650+ Windows SDK is publicly released
+
 if (MSVC)
 	string(REGEX REPLACE "([0-9]+)\\.[0-9]+\\.[0-9]+\\.[0-9]+" "\\1" sdk_version_major $ENV{WindowsSDKVersion})
 	string(REGEX REPLACE "[0-9]+\\.([0-9]+)\\.[0-9]+\\.[0-9]+" "\\1" sdk_version_major2 $ENV{WindowsSDKVersion})
@@ -253,10 +258,7 @@
 	if (${sdk_version_major} GREATER 9 AND ${sdk_version_minor} GREATER 17650)
 		MESSAGE("Using Windows SDK 17650+")
 	else()
-		MESSAGE("Using internal winioctl.h")
-		target_include_directories(ipmctl_os_interface PUBLIC
-			src/os/win/sdk
-		)
+		MESSAGE(FATAL_ERROR "Requires Windows SDK version 17650 or newer.")
 	endif()
 endif()

=== debian/changelog ===
ipmctl (02.00.00.3774+ds-1) unstable; urgency=medium

  * New upstream bugfix release.
  * Update symbols (changed ones are not public API).

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 16 Jun 2020 06:26:28 +0200

ipmctl (02.00.00.3764+ds-1) unstable; urgency=medium

  * New upstream minor release; bumps supported Barlow Pass up to 2.05.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 12 May 2020 15:13:28 +0200

ipmctl (02.00.00.3759+ds-1) unstable; urgency=medium

  * New upstream release -- official 2.0.
  * Update symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 27 Apr 2020 21:10:39 +0200

ipmctl (02.00.00.3722+ds-1) unstable; urgency=medium

  * New upstream snapshot.
  * Update symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 02 Mar 2020 14:13:28 +0100

## ipmctl 02.00.00.3852+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,7 @@
 	endif()
 
 	if(NOT GIT_FOUND OR ${GIT_RETURN_CODE})
-		set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.3774)
+		set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.3852)
 	endif()
 endif()
 
@@ -249,6 +249,9 @@
 	DcpmPkg/common
 	src/os/nvm_api
 	src/os/s_string
+	MdePkg/Include
+	MdePkg/Include/Uefi
+	src/os/efi_shim
 	)
 
 if (MSVC)
@@ -350,5 +353,3 @@
 	DcpmPkg/driver/Utils/PlatformConfigData.c
 	DcpmPkg/driver/Utils/AcpiParsing.c
 	DcpmPkg/driver/Utils/ProcessorAndTopologyInfo.c
-	DcpmPkg/driver/Utils/Interleave.c
-	DcpmPkg/driver/Utils/SmbiosUtility.c

=== debian/changelog ===
ipmctl (02.00.00.3852+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 17 Feb 2021 11:13:16 +0100

ipmctl (02.00.00.3847+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols.
  * Use correct path in non-installed.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 06 Feb 2021 03:33:27 +0100

ipmctl (02.00.00.3844+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 28 Jan 2021 13:48:28 +0100

ipmctl (02.00.00.3833+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols.
  * Update copyright (+ BSD-2-Clause-Patent TianoCore).

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 03 Dec 2020 16:03:53 +0100

ipmctl (02.00.00.3825+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 02 Oct 2020 00:50:44 +0200

ipmctl (02.00.00.3820+ds-1) unstable; urgency=high

  * New upstream release.
    + Fixes provisioning of Apache Pass modules.  Closes: #971369.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 29 Sep 2020 23:53:58 +0200

ipmctl (02.00.00.3809+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 31 Aug 2020 11:39:34 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                pkg-config,
                python3,
                asciidoctor
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/intel/ipmctl
 Vcs-Browser: https://github.com/kilobyte/ipmctl/tree/debian

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,6 @@
 	dh_auto_configure -- \
 	      -DBUILDNUM=`dpkg-parsechangelog -SVersion|cut -d+ -f1`
 
-overide_dh_clean:
+override_dh_clean:
 	dh_clean
 	rm -rf output

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ipmctl-$1.tar.gz%, repack, repacksuffix=+ds, dversionmangle=s/\+ds//" \
   https://github.com/intel/ipmctl/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## ipmctl 02.00.00.3885+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,7 @@
 	endif()
 
 	if(NOT GIT_FOUND OR ${GIT_RETURN_CODE})
-		set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.3852)
+		set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.3885)
 	endif()
 endif()
 
@@ -147,7 +147,7 @@
 if(UNIX)
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DNO_MSABI_VA_FUNCS -std=c99 -Wformat -Wformat-security -D_XOPEN_SOURCE=500 -Wall -Wfatal-errors -MMD -fPIC -fno-strict-aliasing")
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wformat -Wformat-security -D_XOPEN_SOURCE=500 -Drestrict=__restrict__ -Wall -Wfatal-errors -MMD -fPIC -fno-strict-aliasing")
-	set(CMAKE_SHARED_LINKER_FLAGS "-z noexecstack -z relro -z now -pie")
+	set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z noexecstack -z relro -z now -pie")
 elseif(MSVC)
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /GS /DynamicBase /sdl")
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GS /DynamicBase /sdl")
